import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Girl here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Girl  extends Actor
{
private int endDelay = 325;
private int trees = 0;
private int unplantedTrees = 0;
private int seeds = 0;
private int speed = 7;
private int vSpeed = 0;
private int acceleration = 1;
private int jumpStrength = 17;
private GreenfootImage[] images;
private int currentImage = 0;
    /**
     * Act - do whatever the Girl wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
     checkKeys();
     checkFall();
     checkCollision();
     plant();
     end();
    }
    
    public void moveRight()
{
        setLocation (getX() + speed, getY() );
    }
    
        public void moveLeft()
{
        setLocation (getX() - speed, getY() );
    }
    
    public void jump()
    {
        vSpeed = -jumpStrength;
        fall();
    }
    
    public void checkFall()
    {
        if((onPlatform() || onPlatfom2())) {
            vSpeed = 0;
        }
        else{
            fall();
        }
    }
    
    public boolean onPlatform()
    {
        Actor under = getOneObjectAtOffset (0, getImage().getHeight() /2, Platform.class);
        return under != null;
    }
     public boolean onPlatfom2()
    {
        Actor under = getOneObjectAtOffset (0, getImage().getHeight() /2, Platfom2.class);
        return under != null;
    }
    private void checkKeys()
    {
        if (Greenfoot.isKeyDown("left") )
        {
            moveLeft();
            animateLeft();
        }
        
                if (Greenfoot.isKeyDown("right") )
        {
            moveRight();
            animateRight();
        }
        if (Greenfoot.isKeyDown("up"))
        {
            if(onPlatform() || onPlatfom2()){
                jump();
            }
        }
    }
        public void fall()
        {
            setLocation (getX(), getY() + vSpeed);
            vSpeed = vSpeed + acceleration;
        }
        
        public void animateLeft()
        {
            images = new GreenfootImage[6];
            for(int m=0; m < 6; m++){
                images[m] = new GreenfootImage ("girlleft" + m + ".gif");
            }
            currentImage = ( currentImage + 1) % images.length;
            setImage (images[currentImage]);
        }
    
                public void animateRight()
        {
            images = new GreenfootImage[6];
            for(int m=0; m < 6; m++){
                images[m] = new GreenfootImage ("girlright" + m + ".gif");
            }
            currentImage = ( currentImage + 1) % images.length;
            setImage (images[currentImage]);
        }
        
        public void checkCollision()
        {
            // Check to see if we found a seed
            Actor Seed = getOneIntersectingObject(Seed.class);
            if (Seed != null)
                {
                    if (Seed.getY() != 15)
                   {// remove seed
                    getWorld().removeObject(Seed);
                    // Put in corner seed
                    getWorld().addObject (new Seed(),15+22*seeds,15);
                    // Increase Counter
                    seeds ++;
                    if ((seeds % 6) == 0)
                        {unplantedTrees++;}
                }
                }
                
            }
            
            public void plant()
            {
                Actor Tree = getOneIntersectingObject(Tree.class);
            if (Tree == null)
               { 
                if ((onPlatform() && (unplantedTrees > 0)))
                { if (Greenfoot.isKeyDown("space"))
                {
                    getWorld().addObject (new Tree(),getX(),440);
                    unplantedTrees--;
                    trees ++;
                    getWorld().addObject (new Bird(),556,31);
                                    }}
            }}
            public void end()
            {
                if (trees == 3)
                {
                    endDelay--;
               if (endDelay == 0)
               {
                   getWorld().addObject (new EndPage(), 300, 300);
                           getWorld().removeObject(this);
                        }}}
}
